#!/bin/sh
# Vitaly Lipatov <lav@etersoft.ru>, 2004
#    
#      
#     
echo "Update kernel with modules: Vitaly Lipatov <lav@etersoft.ru>, 2004-2005"

#   (   )
TYPESYS=`uname -r | cut -d "-" -f2,3`
RELEASE=.

test -z "$1" || TYPESYS=$1
test -z "$2" || RELEASE=$2

SUDO=sudo
if [ "$UID" == "0" ]
then
	SUDO=
fi
echo "Try to install newest kernel image '$TYPESYS' type"
LISTKER=`$SUDO apt-get install kernel-image-$TYPESYS -y | grep $RELEASE | grep "\#" | grep -v "\["`
LISTKER=`echo $LISTKER | cut -d " " -f 1 | head -n 1`
echo "Install new kernel $LISTKER"
$SUDO apt-get install $LISTKER -y

if [ -n "$LISTKER" ] ; then
    NEWESTKERNEL=`echo $LISTKER | sed -e "s/#/-/g"`
else
    echo "Check for newest kernel..."
    NEWESTKERNEL=`rpm -qa kernel-image-${TYPESYS}* | grep $RELEASE | sort | tail -n 1`
fi

INSTVER=`rpm -q $NEWESTKERNEL --queryformat "%{VERSION}-$TYPESYS-%{RELEASE}"`
echo "Updates modules for kernel: $INSTVER ..."
ALLMODULES=`apt-cache pkgnames kernel-modules | sed -e "s/kernel-modules-//g" | sed -e "s/-.*$//g" | sort | uniq | grep -v kernel`
LISTFORUPDATE=""
for i in $ALLMODULES
do
    PKGNAME=kernel-modules-$i
    if rpm -q $PKGNAME-$TYPESYS >/dev/null
    then
	echo modules-$i is installed, updating...
	LISTFORUPDATE="$LISTFORUPDATE$PKGNAME-$INSTVER "
    fi
done
$SUDO apt-get install $LISTFORUPDATE -y
